# BlackLine

### Overview

The Veza integration for BlackLine enables gathering User, Group and Role assignments from the BlackLine financial automation platform.

### Configuring BlackLine

1. Create a BlackLine user for API access
   * The user must have the `API` Role and be a System Administrator to make the necessary requests
2. Generate an API key for the user for the BlackLine API Administration Portal or Financial Close System
3. Request OAuth 2.0 credentials from the BlackLine customer support team:
   * Required API features: `Accounts`
   * Required scopes: `bl_users`, `bl_mdm`
   * Their team should return a PDF with the OAuth app credentials. Use this support-provided installation form to configure the integration on Veza.

For more detail on obtaining credentials and BlackLine API keys, see [Getting Started](https://developer.blackline.com/get-started) in the official developer documentation.

### Configuring BlackLine on the Veza Platform

1. On the Veza **Integrations** page, add a BlackLine Integration with the following fields:
   * Name - integration name
   * URL - URL for BlackLine instance from installation form e.g. `https://us.api.blackline.com`
   * Username - Username of BlackLine user for the integration
   * API Key - API key generated for the user
   * Client ID - The Client ID from the support-provided installation form
   * Client Secret - The Client Secret from the installation form
   * Instance ID - UUID-type string from the Installation form Scope following the `instance_`. Do not include the scope strings such as bl.users bl.mdm.

**NOTE**: Please contact Blackline Customer Support if you need the values for URL, Username, API key, Client ID, Client Secret and Instance ID.

### Notes and Supported Entities

#### BlackLine Users

| Attribute   | Notes                                     |
| ----------- | ----------------------------------------- |
| `id`        | User login                                |
| `name`      | User full name as configured in BlackLine |
| `is_active` | Boolean True if user is active            |
| `email`     | User's configured email                   |
| `job_title` | User's Job Title if set in BlackLine      |

#### BlackLine Group

| Attribute     | Notes                                        |
| ------------- | -------------------------------------------- |
| `id`          | BlackLine Group ID                           |
| `name`        | Group name                                   |
| `level_name`  | Name of Group Level                          |
| `unique_code` | BlackLine unique code for Group (short name) |
| `parent_id`   | ID of Parent Group if child                  |

#### BlackLine Product (as Resource)

| Attribute | Notes        |
| --------- | ------------ |
| `name`    | Product Name |

#### BlackLine Role

| Attribute | Notes     |
| --------- | --------- |
| `name`    | Role Name |

Roles are assigned to Users or Groups to either BlackLine Application or specific BlackLine Product (resource) as configured in BlackLine.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.veza.com/4yItIzMvkpAvMVFAamTf/integrations/integrations/blackline.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
